# -*- coding: utf8 -*-

import os, json, time
import base64
from requests import Session, codes
from time import localtime, strftime
import aes as EN
import StringIO
import gzip
import xmltv
import urllib

class dodat():
  def __init__(self,
                base,
                login,
                path,
                cachetime=1,
                dbg=False,
                dump_name='',
                timeout=0.5,
                ver = '0.0.0',
                xxx = False,
                os_id = 'pcweb',
                agent_id = 'pcweb',
                app_ver = '0.01',
                proc_cb = None):

    self.__UA = {
                'Host': 'api.iptv.bulsat.com',
                'User-Agent': 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:36.0) Gecko/20100101 Firefox/36.0',
                'Accept':'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
                'Accept-Language': 'en-US,en;q=0.5',
                'Accept-Encoding': 'gzip, deflate',
                'Referer': 'https://test.iptv.bulsat.com/iptv.php',
                'Origin': 'https://test.iptv.bulsat.com',
                'Connection': 'keep-alive',
                'Pragma': 'no-cache',
                }

    self.__log_in = {}
    self.__p_data = {
                'user' : ['',''],
                'device_id' : ['', os_id],
                'device_name' : ['', os_id],
                'os_version' : ['', os_id],
                'os_type' : ['', os_id],
                'app_version' : ['', app_ver],
                'pass' : ['',''],
                }
    self.__path = path
    self.__refresh = int(cachetime * 60 * 60)
    self.__p_data['user'][1] = login['usr']
    self.__log_in['pw'] = login['pass']
    self.__DEBUG_EN = dbg
    self.__t = timeout
    self.__BLOCK_SIZE = 16
    self.__URL_LOGIN = base + '/?auth'
    self.__URL_LIST = base + '/tv/full/live'
    self.__URL_EPG  = base + '/epg/short'
    self.__js = None
    self.__app_version = ver
    self.__x = xxx
    self.__cb = proc_cb

    if agent_id != 'pcweb':
      self.__UA['User-Agent'] = agent_id

    if not os.path.exists(self.__path):
      os.makedirs(self.__path)

  def __log_dat(self, d):
    if self.__DEBUG_EN is not True:
      return
    print '--------- BEGIN ---------'
    if type(d) is str:
      print d
    elif type(d) is dict or type(d).__name__ == 'CaseInsensitiveDict':
      for k, v in d.iteritems():
        print k + ' : ' + str(v)
    elif type(d) is list:
      for l in d:
        print l
    else:
      print 'Todo add type %s' % type(d)
    print '--------- END -----------'

  def __store_data(self):
      with open(os.path.join(self.__path, '', 'data.dat'), 'wb+') as f:
        f.write(unicode(json.dumps(self.__js,
                        sort_keys = True,
                        indent = 1,
                        ensure_ascii=False)))

  def __restore_data(self):
    with open(os.path.join(self.__path, '', 'data.dat'), 'r') as f:
      self.__js = json.load(f)

  def __goforit(self):
    if self.__cb:
      self.__cb({'pr': 0.10, 'str': 'Session'})
    s = Session()
    r = s.post(self.__URL_LOGIN, timeout=self.__t,
                headers=self.__UA)

    if r.status_code == codes.ok:
      if self.__cb:
        self.__cb({'pr': 0.20, 'str': 'Session start'})
      self.__log_in['key'] = r.headers['challenge']
      self.__log_in['session'] = r.headers['ssbulsatapi']

      s.headers.update({'SSBULSATAPI': self.__log_in['session']})

      _text = self.__log_in['pw'] + (self.__BLOCK_SIZE - len(self.__log_in['pw']) % self.__BLOCK_SIZE) * '\0'

      enc = EN.AESModeOfOperationECB(self.__log_in['key'])
      self.__p_data['pass'][1] = base64.b64encode(enc.encrypt(_text))

      self.__log_dat(self.__log_in)
      self.__log_dat(self.__p_data)

      if self.__cb:
        self.__cb({'pr': 0.30, 'str': 'Login start'})

      r = s.post(self.__URL_LOGIN, timeout=self.__t,
                  headers=self.__UA, files=self.__p_data)

      self.__log_dat(r.request.headers)
      self.__log_dat(r.request.body)

      if r.status_code == codes.ok:
        data = r.json()
        if data['Logged'] == 'true':
          self.__log_dat('Login ok')

          if self.__cb:
            self.__cb({'pr': 0.50, 'str': 'Login ok'})

          s.headers.update({'Access-Control-Request-Method': 'POST'})
          s.headers.update({'Access-Control-Request-Headers': 'ssbulsatapi'})

          r = s.options(self.__URL_LIST, timeout=self.__t,
                          headers=self.__UA)

          self.__log_dat(r.request.headers)
          self.__log_dat(r.headers)
          self.__log_dat(str(r.status_code))

          if self.__cb:
            self.__cb({'pr': 0.70, 'str': 'Fetch data'})

          r = s.post(self.__URL_LIST, timeout=self.__t,
                      headers=self.__UA)

          self.__log_dat(r.request.headers)
          self.__log_dat(r.headers)
          if r.status_code == codes.ok:
            self.__char_set = r.headers['content-type'].split('charset=')[1]
            self.__log_dat('get data ok')
            self.__tv_list = r.json()
            self.__js = {}
            self.__log_dat(self.__js)

            if self.__cb:
              self.__cb({'pr': 1.0, 'str': 'Fetch data done'})

            for i, ch in enumerate(self.__tv_list):
              if self.__cb:
                self.__cb({'pr': (float(i) / len(self.__tv_list)), 'str': ('Epg sync %s' % ch['epg_name']).encode('utf-8')})
              if ch.has_key('program'):
                r = s.post(self.__URL_EPG, timeout=self.__t,
                            headers=self.__UA,
                            data={
                              #'epg': 'nownext',
                              'epg': '1week',
                              #'epg': '1day',
                              'channel': ch['epg_name']
                              }
                          )
                if r.status_code == codes.ok:
                  ch['program'] = r.json()[ch['epg_name']]['programme']

            from HTMLParser import HTMLParser as h
            self.__js = json.loads(h().unescape(json.dumps(self.__js).decode(self.__char_set)))

        else:
          raise Exception("LoginFail")

  def __data_fetch(self, f):
    self.__tv_list = None
    if os.path.exists(os.path.join(self.__path, '', 'data.dat')) and f is False:
      self.__restore_data()
      if time.time() - self.__js['ts'] < self.__refresh and self.__js['os_type'] == self.__p_data['os_type'][1]:
        self.__log_dat('Use cache file')
      else:
        self.__log_dat('Use site')
        self.__js = None

    if self.__js is None:
      self.__goforit()
      self.__log_dat('Len: %d' % len(self.__tv_list))
      self.__js['ts'] = divmod(time.time(), self.__refresh)[0] * self.__refresh
      self.__js['app_version'] = self.__app_version
      self.__js['os_type'] = self.__p_data['os_type'][1]
      self.__log_dat('Base time: %s' % time.ctime(self.__js['ts']))
      self.__store_data()

  def gen_all(self, force_refresh = False):
    ret = False
    w = xmltv.Writer(encoding="utf-8",
                      date=str(time.time()),
                      source_info_url="",
                      source_info_name="",
                      generator_info_name="",
                      generator_info_url="")
    self.__data_fetch(force_refresh)

    if self.__tv_list:
      ret = True
      pl = u'#EXTM3U\n'
      dat = [x for x in self.__tv_list if (x['pg'] == 'free' or self.__x)]
      for i, ch in enumerate(dat):
        if self.__cb:
          self.__cb({'pr': (float(i) / len(dat)), 'str': ch['epg_name'].encode('utf-8')})

        pl = pl + '#EXTINF:-1 tvg-id="%s",%s\n%s|User-Agent=%s\n' % (ch['epg_name'], ch['title'], ch['sources'], urllib.quote_plus(self.__UA['User-Agent']))
        w.addChannel(
                    {'display-name': [(ch['title'], u'bg')],
                     'icon': [{'src': ch['logo_selected']}],
                     'id': ch['epg_name'],
                     'url': ['https://test.iptv.bulsat.com']}
                     )
        if ch.has_key('program'):
          for p in ch['program']:
            w.addProgramme(
                          {'start': p['start'],
                           'stop': p['stop'],
                           'title': [(p['title'], u'')],
                           'desc': [(p['desc'], u'')],
                           'category': [(ch['genre'], u'')],
                           'channel': ch['epg_name'],
                           'video': {'quality': ch['quality']},
                           'rating': [{'value': ch['pg']}]}
                          )

      with open(os.path.join(self.__path, '', 'bulsat.m3u'), 'wb+') as f_m3u:
        f_m3u.write(pl.encode('utf-8', 'replace'))

      out = StringIO.StringIO()
      w.write(out, pretty_print=True)

      with gzip.open(os.path.join(self.__path, '', 'bulsat.xml.gz'), 'w+', 9) as f_lmx:
        f_lmx.write(out.getvalue())
      out.close()
    return ret
